<#-- 获取该步骤的表单 -->
<#macro getStepForm ctrlmodel step>
<#compress>
<#if ctrlmodel.getPSDEEditForms()??>
<#list ctrlmodel.getPSDEEditForms() as form>
<#if form.getPSDEWizardForm()??><#assign wizardForm = form.getPSDEWizardForm() />
<#if wizardForm.getPSDEWizardStep()??><#assign wizardStep = wizardForm.getPSDEWizardStep() />
<#if wizardStep.getId() == step.getId()>${form.getName()}</#if>
</#if>
</#if>
</#list>
</#if>
</#compress>  
</#macro>
<template>
    <layout class="app-wizard">
        <#if ctrl.getPSDEWizard?? && ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getPSDEWizardSteps?? && ctrl.getPSDEWizard().getPSDEWizardSteps()??>
        <div class="view-steps">
            <div class="steps_icon" @click="onClickPrev(activeForm)"><i class="el-icon-arrow-left"></i></div>
            <el-steps class="wizard-steps"  :active="(wizardForms.indexOf(activeForm) + 1)" finish-status="success">
        <#list ctrl.getPSDEWizard().getPSDEWizardSteps() as step>
                <el-step :class="{'app-active-step':activeForm==='<@getStepForm ctrlmodel=ctrl step=step />'?true:false}">
                    <template v-slot:title>
                        <div v-popover:<@getStepForm ctrlmodel=ctrl step=step />_popover @click="hanleClick('<@getStepForm ctrlmodel=ctrl step=step />')"><i v-if="activeForm != '<@getStepForm ctrlmodel=ctrl step=step />' && !historyForms.includes('<@getStepForm ctrlmodel=ctrl step=step />')" class="el-icon-lock"></i>${step.getTitle()}</div>
                    </template>
                </el-step>
        </#list>
            </el-steps>
            <div class="steps_icon" @click="onClickNext(activeForm)"><i class="el-icon-arrow-right"></i></div>
        </div>
        <#if ctrl.getPSDEEditForms()??>
        <#list ctrl.getPSDEEditForms() as form>
        <#assign handler = form.getPSAjaxControlHandler() />
        <el-popover v-model="stepVisiable['${form.getName()}']" ref="${form.getName()}_popover" popper-class="app-wizard-popover-container" placement="bottom-<#if form_has_next>start<#else>end</#if>" trigger="click">
            <div class="app-wizard-container">
                <div class="app-wizard-header">
                    <div class="app-wizard-header-extra">
                        <Icon type="md-open" size="18" @click="handleOPen('${form.getName()}')"/>
                        <Icon type="md-close" size="18" @click="handleClose('${form.getName()}')"/>
                    </div>
                </div>
                <div class="popover-title">${form.getLogicName()}</div>
                <div class="app-wizard-content">
                    <view_${form.getName()}
                    :key="'${form.name}'" 
                    :viewState='wizardState'
                    :context="context"
                    :viewparams="viewparams"
                    updateAction="<#if form.getUpdatePSControlAction()?? && form.getUpdatePSControlAction().getPSAppDEMethod()??>${form.getUpdatePSControlAction().getPSAppDEMethod().getCodeName()}</#if>"
                    removeAction="<#if form.getRemovePSControlAction()?? && form.getRemovePSControlAction().getPSAppDEMethod()??>${form.getRemovePSControlAction().getPSAppDEMethod().getCodeName()}</#if>"
                    loadAction="<#if form.getGetPSControlAction()?? && form.getGetPSControlAction().getPSAppDEMethod()??>${form.getGetPSControlAction().getPSAppDEMethod().getCodeName()}</#if>"
            <#if form.getHookEventNames()??>
                <#list form.getHookEventNames() as eventName>
                    @${eventName?lower_case}="${form.name}_${eventName?lower_case}" 
                </#list>
            </#if>
                    name='${form.name}' 
                    ref='${form.name}'>
                    </view_${form.getName()}>
                </div>
                <div class="app-wizard-footer">
                    <i-button  v-if="isVisiable('${form.name}','PREV')" @click="onClickPrev('${form.name}')" ><Icon type="ios-arrow-back"></Icon></i-button>
                    <i-button  v-if="isVisiable('${form.name}','NEXT')" @click="onClickNext('${form.name}')" type="primary" long>下一步</i-button>
                    <i-button  v-if="isVisiable('${form.name}','FINISH')" @click="onClickFinish('${form.name}')" type="primary" long>完成</i-button>
                </div>
            </div>
        </el-popover>
        <drawer class="app-wizard-drawer" :closable="false"  :value="drawerOpenStatus.isOpen && drawerOpenStatus.formName == '${form.name}'"
        :width="600"  title="${form.getLogicName()}" @on-visible-change="onVisibleChange($event)">
            <view_${form.getName()}
            :key="'${form.name}'" 
            :viewState='wizardState'
            :context="context"
            :viewparams="viewparams"
            updateAction="<#if form.getUpdatePSControlAction()?? && form.getUpdatePSControlAction().getPSAppDEMethod()??>${form.getUpdatePSControlAction().getPSAppDEMethod().getCodeName()}</#if>"
            removeAction="<#if form.getRemovePSControlAction()?? && form.getRemovePSControlAction().getPSAppDEMethod()??>${form.getRemovePSControlAction().getPSAppDEMethod().getCodeName()}</#if>"
            loadAction="<#if form.getGetPSControlAction()?? && form.getGetPSControlAction().getPSAppDEMethod()??>${form.getGetPSControlAction().getPSAppDEMethod().getCodeName()}</#if>"
    <#if form.getHookEventNames()??>
        <#list form.getHookEventNames() as eventName>
            @${eventName?lower_case}="${form.name}_${eventName?lower_case}" 
        </#list>
    </#if>
            name='${form.name}' 
            ref='${form.name}'>
            </view_${form.getName()}>
        </drawer>
        </#list>
        </#if>
        </#if>
    </layout> 
</template>
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

    /**
     * 部件行为--init
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public initAction!: string;
    
    /**
     * 部件行为--finish
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public finishAction!: string;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
      * 获取多项数据
      *
      * @returns {any[]}
      * @memberof ${srfclassname('${ctrl.codeName}')}Base
      */
    public getDatas(): any[] {
        return [this.formParam];
    }

    /**
      * 获取单项数据
      *
      * @returns {*}
      * @memberof ${srfclassname('${ctrl.codeName}')}Base
      */
    public getData(): any {
        return this.formParam;
    }

    /**
     * 视图状态订阅对象
     *
     * @public
     * @type {Subject<{action: string, data: any}>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public wizardState: Subject<ViewState> = new Subject();

    /**
     * 当前激活表单
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public activeForm: string = '';

    /**
     * 第一个向导表单
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public firstForm: string = '<#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getFirstPSDEWizardForm()??><#assign firstForm = ctrl.getPSDEWizard().getFirstPSDEWizardForm()>${ctrl.name}_form_${firstForm.getFormTag()}</#if>';

    /**
     * 状态属性
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public stateField: string = '${ctrl.getStatePSAppDEField().getCodeName()?lower_case}';

    /**
     * 向导表单参数
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public formParam: any = {};

    /**
     * 执行过的表单
     *
     * @public
     * @type {Array<string>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public historyForms: Array<string> = [];

    /**
     * 步骤行为集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public stepActions: any = {};

    /**
     * 步骤标识集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public stepTags: any = {};

    /**
     * 步骤是否显示集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public stepVisiable:any = {};

    /**
     * 向导表单集合
     *
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public wizardForms: Array<any> = [];

    /**
     * 当前状态
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public curState = '';

    /**
     * 抽屉状态
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public drawerOpenStatus:any = {
        isOpen:false,
        formName:""
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public created(): void {
        this.regFormActions();
        this.doInit();
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (Object.is(tag, this.name)) {
                    if (Object.is('load', action)) {
                        this.doInit(data);
                    }
                }
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public destroyed() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 注册表单步骤行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public regFormActions() {
      <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getPSDEWizardForms()??>
        <#list ctrl.getPSDEWizard().getPSDEWizardForms() as form>
        this.regFormAction('${ctrl.name}_form_${form.getFormTag()}', [<#if form.getStepActions()??><#list form.getStepActions() as action><#if action_index gt 0>,</#if>'${action}'</#list></#if>],<#if form.getPSDEWizardStep()?? && form.getPSDEWizardStep().getStepTag()??>'${form.getPSDEWizardStep().getStepTag()}'<#else>null</#if>);
        </#list>
      </#if>
    }

    /**
     * 注册表单步骤行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public regFormAction(name: string, actions: Array<string>,stepTag:any) {
        this.stepActions[name] = actions;
        this.stepTags[name] = stepTag;
        this.stepVisiable[name] = false;
        this.wizardForms.push(name);
    }

    /**
     * 计算激活表单
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public computedActiveForm(data:any){
        if(data[this.stateField]){
            if(Object.keys(this.stepTags).length >0){
                Object.keys(this.stepTags).forEach((name:string) =>{
                    if(this.stepTags[name] === data[this.stateField]){
                        this.activeForm = name;
                    }
                })
            }
            if(!this.activeForm){
                this.activeForm = this.firstForm;
            }
        }else{
            this.activeForm = this.firstForm;
        }
        if(this.activeForm) {
            let index = this.wizardForms.indexOf(this.activeForm);
            this.wizardForms.forEach((item:any,inx:number) =>{
                if(inx <= index){
                    this.historyForms.push(item);
                }
            })
        }
    }

    /**
     * 初始化行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public doInit(opt: any = {}) {
        <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getInitPSDEAction()??>
        <#assign action = ctrl.getPSDEWizard().getInitPSDEAction()>
        const arg: any = { ...opt };
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.init(this.initAction, JSON.parse(JSON.stringify(this.context)), arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (response && response.status === 200) {
                this.formParam = response.data;
                if(response.data.${ctrl.getPSAppDataEntity().getCodeName()?lower_case}){
                    Object.assign(this.context,{${ctrl.getPSAppDataEntity().getCodeName()?lower_case}:response.data.${ctrl.getPSAppDataEntity().getCodeName()?lower_case}})
                }
                this.computedActiveForm(response.data);
            }
        }).catch((response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: '错误', desc: response.info });
        });
        </#if>
    }

    /**
     * 表单加载
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public formLoad(name:string) {
        if(name) {
            this.wizardState.next({ tag: name, action: 'load', data: this.formParam });
        }
    }

    /**
     * 完成行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public doFinish() {
        <#if ctrl.getPSDEWizard()?? && ctrl.getPSDEWizard().getFinishPSDEAction()??>
        <#assign action = ctrl.getPSDEWizard().getFinishPSDEAction()>
        let arg: any = {};
        Object.assign(arg, this.formParam);
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.finish(this.finishAction, JSON.parse(JSON.stringify(this.context)), arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.$emit("finish", data);
            }
        }).catch((response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: '错误', desc: response.info });
        });
        </#if>
    }

    /**
     * 向导表单加载完成
     *
     * @param {*} args
     * @param {string} name
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public ${ctrl.name}_formload(args: any, name: string, $event2?: any) {
        if(args) {
            Object.assign(this.formParam, args);
        }
    }

    /**
     * 向导表单保存完成
     *
     * @param {*} args
     * @param {string} name
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public ${ctrl.name}_formsave(args: any, name: string, $event2?: any) {
        Object.assign(this.formParam, args);
        if(Object.is(this.curState, 'NEXT')) {
            if(this.historyForms.indexOf(name) === -1){
                this.historyForms.push(name);
            }
            this.setPopVisiable(name,false);
            if (this.getNextForm(name)) {
                this.activeForm = this.getNextForm(name);
                this.setPopVisiable(this.activeForm,true);
                setTimeout(() => {
                    this.formLoad(this.activeForm);
                }, 1);
            } else {
                this.doFinish();
            }
        }else if(Object.is(this.curState, 'FINISH')) {
            this.doFinish();
        }
    }

    /**
     * 打开链接
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public handleOPen(name:string){
        this.handleClose(name);
        this.drawerOpenStatus.isOpen = true;
        this.drawerOpenStatus.formName = name;
    }

    /**
     * 关闭
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public handleClose(name:string){
        this.setPopVisiable(name,false);
    }

    /**
     * 设置popover是否显示
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public setPopVisiable(name:string,isVisiable:boolean){
        this.stepVisiable[name] = isVisiable;
        (this.$refs[name+'_popover'] as any).showPopper = isVisiable;
    }

    /**
     *  导航条点击事件
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public hanleClick(name:string){
        let activeIndex:number = this.wizardForms.indexOf(this.activeForm);
        let curIndex:number = this.wizardForms.indexOf(name);
        if(curIndex > activeIndex){
            setTimeout(() =>{
                (this.$refs[name+'_popover'] as any).showPopper = false;
            },0)
            return;
        }
        this.stepVisiable[name] = !this.stepVisiable[name];
        if(this.stepVisiable[name]){
            this.formLoad(name);
        }
    }

    /**
     * 获取下一步向导表单
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getNextForm(name:string) {
        let index = this.wizardForms.indexOf(name);
        if(index >= 0) {
            if(this.wizardForms[index + 1]) {
                return this.wizardForms[index + 1];
            }
        }
        return undefined;
    }


    /**
     * 上一步
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onClickPrev(name:string) {
        const length = this.historyForms.length;
        if(length > 1) {
            this.curState = 'PREV';
            let curIndex:number = this.wizardForms.indexOf(name);
            this.setPopVisiable(name,false);
            setTimeout(() => {
                this.setPopVisiable(this.historyForms[curIndex - 1],true);
                this.formLoad(this.historyForms[curIndex - 1]);
            }, 1);
        }
    }

    /**
     * 下一步
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onClickNext(name:string) {
        if(name) {
            if(this.$refs && this.$refs[name]){
                let form: any = this.$refs[name];
                if(form.formValidateStatus()) {
                    this.curState = 'NEXT';
                    this.wizardState.next({ tag: name, action: 'save', data: this.formParam });
                } else {
                    this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                }
            }
        }
    }

    /**
     * 完成
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onClickFinish(name:string) {
        if(name) {
            if(this.$refs && this.$refs[name]){
                let form: any = this.$refs[name];
                if(form.formValidateStatus()) {
                    this.curState = 'FINISH';
                    this.wizardState.next({ tag: name, action: 'save', data: this.formParam });
                } else {
                    this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                }
            }
        }
    }

    /**
     * 是否显示
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public isVisiable(name:string,type: string) {
        const actions: Array<string> = this.stepActions[name];
        if(actions && actions.indexOf(type) !== -1 && Object.is(name,this.activeForm)) {
            return true;
        }else{
            return false;
        }
    }
    /**
     * 抽屉状态改变
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onVisibleChange(value:any){
        if(!value){
            this.drawerOpenStatus.isOpen = false;
        }
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>