<#if view.isBlankMode()>
<div class="index_view ${srffilepath2(view.getCodeName())}<#if view.getPSSysCss?? && view.getPSSysCss()??> ${view.getPSSysCss().getCssName()}</#if>">
    <app-keep-alive :routerList="getRouterList">
        <router-view :key="getRouterViewKey"></router-view>
    </app-keep-alive>
</div>
<#else>
<#if view.getMainMenuAlign()=="LEFT" || view.getMainMenuAlign()=="">
<div class="index_view ${srffilepath2(view.getCodeName())}<#if view.getPSSysCss?? && view.getPSSysCss()??> ${view.getPSSysCss().getCssName()}</#if>">
    <app-studioaction :viewTitle="$t(model.srfCaption)" viewName="${view.getCodeName()?lower_case}"></app-studioaction>
    <layout :class="themeClasses" :style="themeStyle">
        <layout>
            <sider :width="collapseChange ? 64 : 200" hide-trigger v-model="collapseChange">
                <div class="sider-top">
                    <div class="page-logo">
                    <#if view.getAppIconPath() != "">
                        <img v-show="collapseChange" v-if="isEnableAppSwitch" src="${view.getAppIconPath()}" height="16" @click="contextMenuDragVisiable=!contextMenuDragVisiable" />
                        <#else>
                        <span class="menuicon" v-if="isEnableAppSwitch" @click="contextMenuDragVisiable=!contextMenuDragVisiable"><Icon type="md-menu" /></span>
                    </#if>
                        <span v-show="!collapseChange" style="overflow-x: hidden;text-overflow: ellipsis;white-space: nowrap;display: block;text-align: center;font-weight: 300;font-size: 20px;">{{$t(model.srfCaption)}}</span>
                    </div>
                </div>
                ${P.getCtrlCode('appmenu', 'CONTROL.html').code}
                <context-menu-drag v-if="isEnableAppSwitch" :contextMenuDragVisiable="contextMenuDragVisiable"></context-menu-drag>
            </sider>
            <layout>
                <header class="index_header">
                    <div class="header-left" >
                        <div class="page-logo">
                            <i v-show="!collapseChange" class="ivu-icon el-icon-s-fold" @click="handleClick"></i>
                            <i v-show="collapseChange" class="ivu-icon el-icon-s-unfold" @click="handleClick"></i>
                            <app-breadcrumb  :navModel="navModel" indexViewTag="${srffilepath2(view.getCodeName())}"></app-breadcrumb>
                        </div>
                    </div>
                    <div class="header-right" style="display: flex;align-items: center;justify-content: space-between;">
                        <app-header-menus />
                        <app-lang style='font-size: 15px;padding: 0 10px;'></app-lang>
                        <app-orgsector></app-orgsector>
                        <app-user></app-user>
                        <app-theme style="width:45px;display: flex;justify-content: center;"></app-theme>
                    </div>
                </header>
                <content :class="{'index_content':true,'index_tab_content':Object.is(navModel,'tab')?true:false,'index_route_content':Object.is(navModel,'route')?true:false}" :style="{'width':this.collapseChange ? 'calc(100vw - 64px)' : 'calc(100vw - 200px)' }"  @click="contextMenuDragVisiable=false">
                    <tab-page-exp v-if="Object.is(navModel,'tab')"></tab-page-exp>
                    <app-keep-alive :routerList="getRouterList">
                        <router-view :key="getRouterViewKey"></router-view>
                    </app-keep-alive>
                </content>
            </layout>
        </layout>
    </layout>
</div>
<#else>
<div class="index_view <#if view.getPSSysCss?? && view.getPSSysCss()??> ${view.getPSSysCss().getCssName()}</#if>">
    <layout :class="themeClasses" :style="themeStyle">
        <header class="index_header" >
            <div class="header-left">
                <div class="page-logo">
                    <img src="../../../assets/img/logo.png" height="32" />
                    <span style="display: inline-block;margin-left: 10px;font-size: 22px;">{{$t(model.srfCaption)}}</span>
                </div>
                <div style="margin-left: 50px;">
                ${P.getCtrlCode('appmenu', 'CONTROL.html').code}
                </div>
            </div>
            <div class="header-right" style="display: flex;align-items: center;justify-content: space-between;">
                <app-header-menus />
                <app-lang style='font-size: 15px;padding: 0 10px;'></app-lang>
                <app-orgsector></app-orgsector>
                <app-user></app-user>
                <app-theme style="width:45px;display: flex;justify-content: center;"></app-theme>
            </div>
        </header>
        <content style="height:calc(100vh - 50px);"  @click="contextMenuDragVisiable=false">  
            <router-view></router-view>
        </content>
    </layout>
</div>
</#if>
</#if>
